[glib-networking] tls: Clean up testing and coverage support



commit cb4057ca631f2caf12b9241385c0deb8e9d84252
Author: Stef Walter <stefw collabora co uk>
Date:   Fri Aug 19 14:53:36 2011 +0200

    tls: Clean up testing and coverage support
    
     * Make 'make check' work properly with tests
     * Use a similar approach to glib to running gtester and hooking
       in the unit tests to 'make check'
     * Use GIO_EXTRA_MODULES to load the in-tree gnutls module.
     * Add coverage support similar to glib
    
    https://bugzilla.gnome.org/show_bug.cgi?id=656906

 .gitignore                 |    2 +
 Makefile.decl              |   88 ++++++++++++++++++++++++++++++++++++++++++++
 configure.ac               |   58 +++++++++++++++++++++++++++++
 proxy/libproxy/Makefile.am |    2 +-
 tls/gnutls/Makefile.am     |    2 +-
 tls/tests/Makefile.am      |    7 ++-
 6 files changed, 155 insertions(+), 4 deletions(-)
---
diff --git a/.gitignore b/.gitignore
index 236597e..4c98074 100644
--- a/.gitignore
+++ b/.gitignore
@@ -23,6 +23,8 @@ glib-gettextize
 glib-zip
 gtk-doc.make
 compile
+glib-lcov.info
+glib-lcov
 
 INSTALL
 ChangeLog
diff --git a/Makefile.decl b/Makefile.decl
index e69de29..72d0e15 100644
--- a/Makefile.decl
+++ b/Makefile.decl
@@ -0,0 +1,88 @@
+# GLIB - Library of useful C routines
+
+GTESTER = gtester 			# for non-GLIB packages
+GTESTER_REPORT = gtester-report		# for the GLIB package
+
+# initialize variables for unconditional += appending
+EXTRA_DIST =
+TEST_PROGS =
+
+### testing rules
+
+# test: run all tests in cwd and subdirs
+test: test-nonrecursive
+	@ for subdir in $(SUBDIRS) . ; do \
+	    test "$$subdir" = "." -o "$$subdir" = "po" || \
+	    ( cd $$subdir && $(MAKE) $(AM_MAKEFLAGS) $@ ) || exit $? ; \
+	  done
+
+# test-nonrecursive: run tests only in cwd
+test-nonrecursive: ${TEST_PROGS}
+	@test -z "${TEST_PROGS}" || ${TEST_ENVIRONMENT} ${GTESTER} --verbose ${TEST_PROGS}
+
+# test-report: run tests in subdirs and generate report
+# perf-report: run tests in subdirs with -m perf and generate report
+# full-report: like test-report: with -m perf and -m slow
+test-report perf-report full-report:	${TEST_PROGS}
+	@test -z "${TEST_PROGS}" || { \
+	  case $@ in \
+	  test-report) test_options="-k";; \
+	  perf-report) test_options="-k -m=perf";; \
+	  full-report) test_options="-k -m=perf -m=slow";; \
+	  esac ; \
+	  if test -z "$$GTESTER_LOGDIR" ; then	\
+	    ${GTESTER} --verbose $$test_options -o test-report.xml ${TEST_PROGS} ; \
+	  elif test -n "${TEST_PROGS}" ; then \
+	    ${GTESTER} --verbose $$test_options -o `mktemp "$$GTESTER_LOGDIR/log-XXXXXX"` ${TEST_PROGS} ; \
+	  fi ; \
+	}
+	@ ignore_logdir=true ; \
+	  if test -z "$$GTESTER_LOGDIR" ; then \
+	    GTESTER_LOGDIR=`mktemp -d "\`pwd\`/.testlogs-XXXXXX"`; export GTESTER_LOGDIR ; \
+	    ignore_logdir=false ; \
+	  fi ; \
+	  if test -d "$(top_srcdir)/.git" ; then \
+	    REVISION=`git describe` ; \
+	  else \
+	    REVISION=$(VERSION) ; \
+	  fi ; \
+	  for subdir in $(SUBDIRS) . ; do \
+	    test "$$subdir" = "." -o "$$subdir" = "po" || \
+	    ( cd $$subdir && $(MAKE) $(AM_MAKEFLAGS) $@ ) || exit $? ; \
+	  done ; \
+	  $$ignore_logdir || { \
+	    echo '<?xml version="1.0"?>'              > $  xml ; \
+	    echo '<report-collection>'               >> $  xml ; \
+	    echo '<info>'                            >> $  xml ; \
+	    echo '  <package>$(PACKAGE)</package>'   >> $  xml ; \
+	    echo '  <version>$(VERSION)</version>'   >> $  xml ; \
+	    echo "  <revision>$$REVISION</revision>" >> $  xml ; \
+	    echo '</info>'                           >> $  xml ; \
+	    for lf in `ls -L "$$GTESTER_LOGDIR"/.` ; do \
+	      sed '1,1s/^<?xml\b[^>?]*?>//' <"$$GTESTER_LOGDIR"/"$$lf" >> $  xml ; \
+	    done ; \
+	    echo >> $  xml ; \
+	    echo '</report-collection>' >> $  xml ; \
+	    rm -rf "$$GTESTER_LOGDIR"/ ; \
+	    ${GTESTER_REPORT} --version 2>/dev/null 1>&2 ; test "$$?" != 0 || ${GTESTER_REPORT} $  xml >$  html ; \
+	  }
+.PHONY: test test-report perf-report full-report test-nonrecursive
+
+.PHONY: lcov genlcov lcov-clean
+# use recursive makes in order to ignore errors during check
+lcov:
+	find $(top_builddir) -name '*.gcda' -delete
+	-$(MAKE) $(AM_MAKEFLAGS) -k check
+	$(MAKE) $(AM_MAKEFLAGS) genlcov
+
+genlcov:
+	$(LTP) --directory $(top_builddir) --capture --output-file glib-lcov.info --test-name GLIB_PERF --no-checksum --compat-libtool
+	LANG=C $(LTP_GENHTML) --prefix $(top_builddir) --output-directory glib-lcov --title "GLib Code Coverage" --legend --show-details glib-lcov.info
+
+lcov-clean:
+	-$(LTP) --directory $(top_builddir) -z
+	-rm -rf glib-lcov.info glib-lcov
+	-find -name '*.gcda' -print | xargs rm
+
+# run tests in cwd as part of make check
+check-local: test-nonrecursive
diff --git a/configure.ac b/configure.ac
index 98a54c3..8d8e41f 100644
--- a/configure.ac
+++ b/configure.ac
@@ -150,6 +150,64 @@ if test "$GCC" = "yes" -a "$set_more_warnings" != "no"; then
 	done
 fi
 
+dnl ************************************
+dnl *** Enable lcov coverage reports ***
+dnl ************************************
+
+AC_ARG_ENABLE(gcov,
+  AS_HELP_STRING([--enable-gcov],
+		 [Enable gcov]),
+  [use_gcov=$enableval], [use_gcov=no])
+
+if test "x$use_gcov" = "xyes"; then
+  dnl we need gcc:
+  if test "$GCC" != "yes"; then
+    AC_MSG_ERROR([GCC is required for --enable-gcov])
+  fi
+
+  ltp_version_list="1.6 1.7 1.8 1.9"
+  AC_CHECK_PROG(LTP, lcov, lcov)
+  AC_CHECK_PROG(LTP_GENHTML, genhtml, genhtml)
+
+  if test "$LTP"; then
+    AC_CACHE_CHECK([for ltp version], glib_cv_ltp_version, [
+      glib_cv_ltp_version=invalid
+      ltp_version=`$LTP -v 2>/dev/null | $SED -e 's/^.* //'`
+      for ltp_check_version in $ltp_version_list; do
+        if test "$ltp_version" = "$ltp_check_version"; then
+          glib_cv_ltp_version="$ltp_check_version (ok)"
+        fi
+      done
+    ])
+  else
+    ltp_msg="To enable code coverage reporting you must have one of the following LTP versions installed: $ltp_version_list"
+    AC_MSG_ERROR([$ltp_msg])
+  fi
+
+  case $glib_cv_ltp_version in
+    ""|invalid[)]
+      ltp_msg="You must have one of the following versions of LTP: $ltp_version_list (found: $ltp_version)."
+      AC_MSG_ERROR([$ltp_msg])
+      LTP="exit 0;"
+      ;;
+  esac
+
+  if test -z "$LTP_GENHTML"; then
+    AC_MSG_ERROR([Could not find genhtml from the LTP package])
+  fi
+
+  AC_DEFINE(HAVE_GCOV, 1, [Whether you have gcov])
+
+  dnl Remove all optimization flags from CFLAGS
+  changequote({,})
+  CFLAGS=`echo "$CFLAGS" | $SED -e 's/-O[0-9]*//g'`
+  changequote([,])
+
+  dnl Add the special gcc flags
+  CFLAGS="$CFLAGS -O0 -fprofile-arcs -ftest-coverage"
+  LDFLAGS="$LDFLAGS -lgcov"
+fi
+
 dnl *****************************
 dnl *** done                  ***
 dnl *****************************
diff --git a/proxy/libproxy/Makefile.am b/proxy/libproxy/Makefile.am
index e7b373b..2e763c5 100644
--- a/proxy/libproxy/Makefile.am
+++ b/proxy/libproxy/Makefile.am
@@ -44,7 +44,7 @@ servicedir = $(datadir)/dbus-1/services
 service_in_files = org.gtk.GLib.PACRunner.service.in
 service_DATA = $(service_in_files:.service.in=.service)
 
-EXTRA_DIST = $(service_in_files)
+EXTRA_DIST += $(service_in_files)
 CLEANFILES = $(service_DATA)
 
 org.gtk.GLib.PACRunner.service: org.gtk.GLib.PACRunner.service.in Makefile
diff --git a/tls/gnutls/Makefile.am b/tls/gnutls/Makefile.am
index f9f1965..745f0ce 100644
--- a/tls/gnutls/Makefile.am
+++ b/tls/gnutls/Makefile.am
@@ -61,7 +61,7 @@ BUILT_SOURCES = 		\
 	gnutls-marshal.h	\
 	gnutls-marshal.c
 
-EXTRA_DIST = 			\
+EXTRA_DIST += 			\
 	gnutls-marshal.list
 
 CLEANFILES = 			\
diff --git a/tls/tests/Makefile.am b/tls/tests/Makefile.am
index 1e9b316..6fd538b 100644
--- a/tls/tests/Makefile.am
+++ b/tls/tests/Makefile.am
@@ -13,11 +13,14 @@ noinst_PROGRAMS = $(TEST_PROGS)
 LDADD  = \
 	$(GLIB_LIBS)
 
-TEST_PROGS =          \
+TEST_ENVIRONMENT =   \
+	GIO_EXTRA_MODULES=$(top_builddir)/tls/gnutls/.libs
+
+TEST_PROGS +=         \
 	tls           \
 	$(NULL)
 
-EXTRA_DIST = \
+EXTRA_DIST += \
 	files \
 	$(NULL)
 



[Date Prev][Date Next]   [Thread Prev][Thread Next]   [Thread Index] [Date Index] [Author Index]